﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Progresser extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		
		//SETTINGS
		private var stepper:Number =10;
		private var separator:Number = 100;
		private var counter:Number;
		private var line:Number;
		private var positionx:Number;
		private var positiony:Number;
		private var rot:Number;
		var definex:Number;
		
		public function Progresser()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,moveHandler);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		private function moveHandler(e:MouseEvent):void
		{
			positionx = e.stageX;
			positiony = e.stageY;
			addEventListener(Event.ENTER_FRAME, draw);
			data = null;
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			removeChildAt(0);
			data = null;
			definex = Math.random()*2;
			stepper = Math.random()*100;
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChildAt(background,0);
			drawer = new Sprite();
			counter = 0;
			line = 0;
			rot = 0;
		}
		
		private function draw(e:Event):void
		{
			if(data == null){
				setup();
			}
			counter++;
			drawer.graphics.clear();
			var _height:Number = stage.stageHeight/stepper;
			var _width:Number = stage.stageWidth/separator * counter;
			var posx:Number = 300 * definex;
			var posy:Number = positiony-stepper;
			var opacite:Number = Math.random()*.1;
			
			//dessiner progressivement par ligne un rectangle avec alpha dépendant du séparator
			rot-= new int(rot/360);
			drawer.graphics.beginFill(0xffff00,1/separator);
			drawer.graphics.drawRect(posx,posy,_width,_height);
			drawer.graphics.beginFill(0x00ffff,1/separator);
			drawer.graphics.drawRect(posx,posy+_height,-_width,-_height);
			graphics.lineTo(x,y);
			drawer.graphics.endFill();
			
			//dessiner dans le bmpdt
			data.draw(drawer);
			
			//condition
			if(_width >= stage.stageWidth){
				counter = 0;
				line++;
			}
			if(posy>=stage.stageHeight){
				line = 0;
			}
		}
		
	}
}